page	65,132
TITLE	NSETVER - Lie to NW function E3/11 (c) RoxWare land
;-------------------------------------------------------------------------
;
;	When you are a programmer you do stupid things, like taking the
;	version number of something and using it as an index into an array
;	without checking its bounds. Instead you should do something sensible
;	like yelling "Hey! I was not tested for XYZZY 4.1!! Permission to
;	treat as 3.x???". This way people will think of you kindly in the
;	future. Instead of saying nasty things about you, like I have been
;	cursing the Creators of CPBACKUP lately......
;
;	This program does one thing, and rather well. It lies about your
;	fileservers age. It will answer 3.12 to any E3/11 call. No matter
;	the real version. All other data returned from said call will
;	pass unmolested. This will make Central Point Backup 7.x run on
;	NetWare 4.1. It will not back up the NDS however.
;
;	Disclaimer: YOU USE THIS SOFTWARE AT YOUR OWN RISK!
;
;	By Anders Gustafsson 95.10.03
;-------------------------------------------------------------------------
	.286			;We require a 286!

CR	EQU	0dh
LF	EQU	0ah
BEL	EQU	07
TRUE	EQU	0ffh
FALSE	EQU	0

CODE	SEGMENT
	ASSUME DS:CODE, SS:CODE ,CS:CODE ,ES:CODE
	ORG	0100H

	ORG	100H

start:	jmp	install

;-------------------------------------------------------------------------
SUBTTL	Data area
OLD21	DW	0000			;Old int 21 offset
OLD21a	DW	0000			;Old int 21 segment

action	dw	0


;---------------------------------------------------------------------------
;	int21	Chains into int 21
;
MARKER	DB	'AG'
int21	proc	far	
	pushf

	cmp	Ah,0E3h		;Is it our FN
	jne	ex21		;No! call old handler

	;popf

intE3:	cmp	byte ptr ds:[si+2],11h
	jne	ex21

	pushf				; Set up since old handler returns
	call	dword ptr cs:old21	; with an IRET
	sti

	mov	byte ptr es:[di+50],3d
	mov	byte ptr es:[di+51],12d
	popf
exit:

	iret

ex21:
	popf
	JMP	DWORD PTR CS:OLD21	;FAR JUMP TO OLD int 21 HANDLER

int21	endp

	db	'CODEND'
codend	equ	$
;----------------------------- END OF DATA --------------------------------
;
;	Disposable data and code starts here!
;
install:MOV	DX,offset signon 	;Tell them we are here
	MOV	AH,9
	INT	21h

i2:	push	cs
	pop	ds

	mov	ah,35h		;Get interrupt vector for int 21
	mov	al,21h
	int	21h
	mov	old21,bx	;Save offset
	mov	old21a,es	;Save segment
	CMP	WORD PTR es:[bx-2],'GA'	;Check for existence of marker
	jne	notlod
	mov	dx,offset loaded;Print error message if we find an id
	mov	ah,09h		;indicating we are already loaded
	int	21h
	jmp	errxit

notlod:	
	push	cs
	pop	ds

	mov	dx,offset int21	;Set new interrupt for int 16
	mov	ah,25h
	mov	al,21h
	int	21h

REM$KEEP:
	MOV	AX,OFFSET CODEND	;AX NOW HOLDS END OF RESIDENT CODE
	xor	dx,dx
	MOV	Cx,10H			;CONVERT TO PARAGRAPHS BY
	DIV	Cx			;DIVIDING BY 10H
	INC	Ax
	STI
	MOV	DX,AX
	MOV	AX,3100H		;retcode = 0 if successful load
	INT	21H

;
;	Error exit
;
errxit:	mov	ax,4C01H		;terminate with return code  1
	INT	21H

;
;
signon	db	'NSETVER Patch v 0.1   (c) RoxWare 95.10.03',CR,LF
	db	'Svara 3.12 vid alla E3/11 anrop',CR,LF,'$'
loaded	db	'Patch redan laddad.',CR,LF,BEL,'$'

CODE 	ENDS
;
END	start
